## pynest2d 4.8.0

=== CMakeLists.txt ===
# Copyright (c) 2020 Ultimaker B.V.
# pynest2d is released under the terms of the LGPLv3 or higher.

project(pynest2d)
cmake_minimum_required(VERSION 3.6)  # Lowest version it's been tested with.

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# Requirements.
find_package(PythonInterp 3.5 REQUIRED)  # Dependency of SIP.
find_package(PythonLibs 3.5 REQUIRED)  # Dependency of SIP.
find_package(SIP REQUIRED)  # To create Python bindings.
find_package(libnest2d REQUIRED)  # The library we're creating bindings for.
find_package(Clipper REQUIRED)  # Dependency of libnest2d.
find_package(NLopt REQUIRED)  # Dependency of libnest2d.
find_package(Boost REQUIRED)  # Dependency of libnest2d.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DLIBNEST2D_GEOMETRIES_clipper -DLIBNEST2D_OPTIMIZERS_nlopt -DLIBNEST2D_THREADING_std")  # Tell libnest2d to use Clipper and NLopt, and standard threads.

# Some build options.
set(CMAKE_CXX_STANDARD 11)
if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()
if(UNIX)
    # Want to be able to move symbols from the Clipper library.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
endif()
if(NOT DEFINED LIB_SUFFIX)
    set(LIB_SUFFIX "")
endif()

# Building and linking.
set(SIP_EXTRA_FILES_DEPEND
    src/BottomLeftConfig.sip
    src/Box.sip
    src/Circle.sip
    src/DJDHeuristicConfig.sip
    src/Item.sip
    src/ItemGroup.sip
    src/NfpConfig.sip
    src/Point.sip
    src/Rectangle.sip
    src/String.sip
)

set(SIP_EXTRA_OPTIONS -g)  # Always release the GIL before calling C++ methods.
include_directories(src/ ${SIP_INCLUDE_DIRS} ${Python3_INCLUDE_DIRS} ${CLIPPER_INCLUDE_DIRS} ${NLopt_INCLUDE_DIRS} ${LIBNEST2D_INCLUDE_DIRS})
add_sip_python_module(pynest2d src/Pynest2D.sip ${CLIPPER_LIBRARIES} ${NLopt_LIBRARIES})

=== debian/changelog ===
pynest2d (4.8.0-2) unstable; urgency=medium

  * Cherry-pick Gregor's Python3_SITEARCH hack from libsavitar to enable
    installation to python-version-specific locations. (Closes: #976613)

 -- Christoph Berg <myon@debian.org>  Tue, 08 Dec 2020 22:11:58 +0100

pynest2d (4.8.0-1) unstable; urgency=medium

  * Initial Debian release.

 -- Christoph Berg <myon@debian.org>  Thu, 26 Nov 2020 22:27:08 +0100

=== debian/control ===
Source: pynest2d
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders:
 Gregor Riepl <onitake@gmail.com>,
 Christoph Berg <myon@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libboost-dev,
 libnest2d-dev,
 libnlopt-cxx-dev,
 libpolyclipping-dev,
 pkg-config,
 python3-all-dev,
 python3-sip-dev,
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/Ultimaker/pynest2d
Vcs-Browser: https://salsa.debian.org/3dprinting-team/pynest2d
Vcs-Git: https://salsa.debian.org/3dprinting-team/pynest2d.git

Package: python3-pynest2d
Section: python
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${sip3:Depends},
 ${shlibs:Depends},
Description: Python bindings for libnest2d
 This repository contains CPython bindings for libnest2d, a library to pack 2D
 polygons into a small space. Libnest2d implements the 2D bin packing problem.
 The objective is to allow libnest2d to be called from Python using Numpy.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_CONFIGURE_ARGS=-DPYVER={version}

%:
	dh $@ --buildsystem=pybuild --with python3 --with sip3

## pynest2d 4.13~beta

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,19 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
 # Requirements.
-find_package(PythonInterp 3.5 REQUIRED)  # Dependency of SIP.
-find_package(PythonLibs 3.5 REQUIRED)  # Dependency of SIP.
+# FIXME: Remove the code for CMake <3.12 once we have switched over completely.
+# FindPython3 is a new module since CMake 3.12. It deprecates FindPythonInterp and FindPythonLibs.
+if(${CMAKE_VERSION} VERSION_LESS 3.12)
+    # FIXME: Use FindPython3 to find Python, new in CMake 3.12.
+    # However currently on our CI server it finds the wrong Python version and then doesn't find the headers.
+    find_package(PythonInterp 3.5 REQUIRED)
+    find_package(PythonLibs 3.5 REQUIRED)
+
+else()
+    # Use FindPython3 for CMake >=3.12
+    find_package(Python3 3.5 REQUIRED COMPONENTS Interpreter Development)
+endif()
+
 find_package(SIP REQUIRED)  # To create Python bindings.
 find_package(libnest2d REQUIRED)  # The library we're creating bindings for.
 find_package(Clipper REQUIRED)  # Dependency of libnest2d.
@@ -17,7 +28,7 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DLIBNEST2D_GEOMETRIES_clipper -DLIBNEST2D_OPTIMIZERS_nlopt -DLIBNEST2D_THREADING_std")  # Tell libnest2d to use Clipper and NLopt, and standard threads.
 
 # Some build options.
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
 endif()
@@ -44,6 +55,6 @@
     src/String.sip
 )
 
-set(SIP_EXTRA_OPTIONS -g)  # Always release the GIL before calling C++ methods.
+set(SIP_EXTRA_OPTIONS -g -n PyQt5.sip)  # Always release the GIL before calling C++ methods. -n PyQt5.sip is required to not get the PyCapsule error
 include_directories(src/ ${SIP_INCLUDE_DIRS} ${Python3_INCLUDE_DIRS} ${CLIPPER_INCLUDE_DIRS} ${NLopt_INCLUDE_DIRS} ${LIBNEST2D_INCLUDE_DIRS})
 add_sip_python_module(pynest2d src/Pynest2D.sip ${CLIPPER_LIBRARIES} ${NLopt_LIBRARIES})

=== debian/changelog ===
pynest2d (4.13~beta-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.1, no changes needed.

  [ Christoph Berg ]
  * New upstream version 4.13~beta.
  * Depend on python3-pyqt5.

 -- Christoph Berg <myon@debian.org>  Mon, 17 Jan 2022 12:33:41 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  pkg-config,
  python3-all-dev,
  python3-sip-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/Ultimaker/pynest2d
 Vcs-Browser: https://salsa.debian.org/3dprinting-team/pynest2d
@@ -26,6 +26,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ python3-pyqt5,
  ${misc:Depends},
  ${python3:Depends},
  ${sip3:Depends},

## pynest2d 5.0.0

=== CMakeLists.txt ===
# Copyright (c) 2022 Ultimaker B.V.
# pynest2d is released under the terms of the LGPLv3 or higher.

project(pynest2d)
cmake_minimum_required(VERSION 3.20)  # Lowest version it's been tested with.
include(cmake/StandardProjectSettings.cmake)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(NOT DEFINED Python_VERSION)
    set(Python_VERSION
            3.10
            CACHE STRING "Python Version" FORCE)
    message(STATUS "Setting Python version to ${Python_VERSION}. Set Python_VERSION if you want to compile against an other version.")
endif()
if(APPLE)
    set(Python_FIND_FRAMEWORK NEVER)
endif()
find_package(cpython ${Python_VERSION} QUIET COMPONENTS Interpreter Development)
if(NOT TARGET cpython::cpython)
    find_package(Python ${Python_VERSION} EXACT REQUIRED COMPONENTS Interpreter Development)
else()
    add_library(Python::Python ALIAS cpython::python)
    set(Python_SITEARCH "${CMAKE_INSTALL_PREFIX}/lib/python${Python_VERSION}/site-packages")
    set(Python_EXECUTABLE ${cpython_PACKAGE_FOLDER_RELEASE}/bin/python3)
    set(ENV{PYTHONPATH} ${Python_SITEARCH})
endif()
message(STATUS "Linking and building ${project_name} against Python ${Python_VERSION}")

find_package(SIP REQUIRED 6.5.0)

find_package(Libnest2D REQUIRED)  # The library we're creating bindings for.

add_library(pynest2d INTERFACE)
set_project_standards(pynest2d)
use_threads(pynest2d)
set_rpath(TARGETS
            pynest2d
          PATHS
            "$<$<PLATFORM_ID:Linux>:usr/bin>"
            "$<$<PLATFORM_ID:Linux>:usr/bin/lib>"
            "$<$<PLATFORM_ID:Darwin>:../lib>"
            "$<$<PLATFORM_ID:Darwin>:../Resources/lib>"
            "../../"  # In distributions of Cura, the libnest2d dependency is 2 directories up from where pynest2d gets installed.
          RELATIVE)

target_include_directories(pynest2d
        INTERFACE
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/>
        )

find_package(Threads)
find_package(clipper)
find_package(NLopt)
find_package(Boost)
target_link_libraries(pynest2d INTERFACE Libnest2D::libnest2d Python::Python Threads::Threads clipper::clipper NLopt::nlopt boost::boost)

add_sip_module(pynest2d)
if(Python_SITELIB_LOCAL)
    install_sip_module(pynest2d ${Python_SITELIB_LOCAL})
else()
    install_sip_module(pynest2d)
endif()

=== debian/changelog ===
pynest2d (5.0.0-3build5) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 10:23:38 +0000

pynest2d (5.0.0-3build4) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 15:59:55 +0000

pynest2d (5.0.0-3build3) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 15 Nov 2024 04:37:39 +0100

pynest2d (5.0.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:20:50 +1100

pynest2d (5.0.0-3build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:14:49 +0100

pynest2d (5.0.0-3) unstable; urgency=medium

  * Remove dependency on SIP 4.x, it's no longer needed

 -- Gregor Riepl <onitake@gmail.com>  Thu, 11 Jan 2024 11:43:13 +0100

pynest2d (5.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Christoph Berg <myon@debian.org>  Sun, 02 Jul 2023 19:54:11 +0000

pynest2d (5.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 5.0.0
  * Build-depend on the new sip tools (6.6.1).
  * Bump dependency to python3-pyqt6.
  * Refresh patches.

 -- Sebastian Kuzminsky <seb@highlab.com>  Wed, 25 May 2022 10:34:05 -0600

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: pynest2d
 Priority: optional
-Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders:
  Gregor Riepl <onitake@gmail.com>,
  Christoph Berg <myon@debian.org>,
@@ -14,7 +15,8 @@
  libpolyclipping-dev,
  pkg-config,
  python3-all-dev,
- python3-sip-dev,
+ python3-sipbuild,
+ sip-tools
 Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/Ultimaker/pynest2d
@@ -26,10 +28,9 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- python3-pyqt5,
+ python3-pyqt6,
  ${misc:Depends},
  ${python3:Depends},
- ${sip3:Depends},
  ${shlibs:Depends},
 Description: Python bindings for libnest2d
  This repository contains CPython bindings for libnest2d, a library to pack 2D

=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,4 @@
 export PYBUILD_CONFIGURE_ARGS=-DPYVER={version}
 
 %:
-	dh $@ --buildsystem=pybuild --with python3 --with sip3
+	dh $@ --buildsystem=pybuild --with python3

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/pynest2d-$1\.tar\.gz/,uversionmangle=s/-beta/~beta/ \
  https://github.com/Ultimaker/pynest2d/tags .*/(\d\.\S+)\.tar\.gz
